searchData={"items":[{"type":"module","title":"Hangman.Engine","doc":"Models the _Hangman Game_. Times out after 30 minutes of inactivity.\n\n###","ref":"Hangman.Engine.html"},{"type":"module","title":"Based on the course [Elixir for Programmers](https://codestool.coding-gnome.com/courses/elixir-for-programmers) by Dave Thomas. - Hangman.Engine","doc":"","ref":"Hangman.Engine.html#module-based-on-the-course-elixir-for-programmers-https-codestool-coding-gnome-com-courses-elixir-for-programmers-by-dave-thomas"},{"type":"function","title":"Hangman.Engine.end_game/1","doc":"Stops a game server process normally. It won't be restarted.","ref":"Hangman.Engine.html#end_game/1"},{"type":"function","title":"Examples - Hangman.Engine.end_game/1","doc":"iex> alias Hangman.Engine\n    iex> Engine.new_game(\"Ben\")\n    iex> Engine.end_game(\"Ben\")\n    :ok","ref":"Hangman.Engine.html#end_game/1-examples"},{"type":"function","title":"Hangman.Engine.make_move/2","doc":"Makes a move by guessing a letter.","ref":"Hangman.Engine.html#make_move/2"},{"type":"function","title":"Examples - Hangman.Engine.make_move/2","doc":"iex> alias Hangman.Engine\n    iex> Engine.new_game(\"Ed\")\n    iex> Engine.make_move(\"Ed\", \"a\").game_state in [:good_guess, :bad_guess]\n    true","ref":"Hangman.Engine.html#make_move/2-examples"},{"type":"function","title":"Hangman.Engine.new_game/1","doc":"Starts a new game server process and supervises it.","ref":"Hangman.Engine.html#new_game/1"},{"type":"function","title":"Examples - Hangman.Engine.new_game/1","doc":"iex> alias Hangman.Engine\n    iex> {:ok, game_id} = Engine.new_game(\"Meg\")\n    iex> {:error, {:already_started, ^game_id}} = Engine.new_game(\"Meg\")\n    iex> is_pid(game_id)\n    true","ref":"Hangman.Engine.html#new_game/1-examples"},{"type":"function","title":"Hangman.Engine.tally/1","doc":"Returns the tally of a game.","ref":"Hangman.Engine.html#tally/1"},{"type":"function","title":"Examples - Hangman.Engine.tally/1","doc":"iex> alias Hangman.Engine\n    iex> Engine.new_game(\"Jim\")\n    iex> tally = Engine.tally(\"Jim\")\n    iex> %{\n    ...>   game_state: :initializing,\n    ...>   turns_left: 7,\n    ...>   letters: letters,\n    ...>   guesses: []\n    ...> } = tally\n    iex> all_underscores? = Enum.all?(letters, & &1 == \"_\")\n    iex> is_list(letters) and length(letters) > 0 and all_underscores?\n    true","ref":"Hangman.Engine.html#tally/1-examples"},{"type":"module","title":"Hangman.Engine.DynGameSup","doc":"A supervisor that starts game server processes dynamically.","ref":"Hangman.Engine.DynGameSup.html"},{"type":"function","title":"Hangman.Engine.DynGameSup.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hangman.Engine.DynGameSup.html#child_spec/1"},{"type":"function","title":"Hangman.Engine.DynGameSup.init/1","doc":"","ref":"Hangman.Engine.DynGameSup.html#init/1"},{"type":"function","title":"Hangman.Engine.DynGameSup.start_link/1","doc":"","ref":"Hangman.Engine.DynGameSup.html#start_link/1"},{"type":"module","title":"Hangman.Engine.GameRecovery","doc":"Makes processes under the top supervisor fault-tolerant. If any crashes (or\nis killed), it is immediately restarted and the system remains undisturbed.","ref":"Hangman.Engine.GameRecovery.html"},{"type":"function","title":"Hangman.Engine.GameRecovery.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hangman.Engine.GameRecovery.html#child_spec/1"},{"type":"function","title":"Hangman.Engine.GameRecovery.init/1","doc":"","ref":"Hangman.Engine.GameRecovery.html#init/1"},{"type":"function","title":"Hangman.Engine.GameRecovery.start_link/1","doc":"","ref":"Hangman.Engine.GameRecovery.html#start_link/1"},{"type":"module","title":"Hangman.Engine.GameServer","doc":"A server process that holds a game struct as its state.\nTimes out after 30 minutes of inactivity.","ref":"Hangman.Engine.GameServer.html"},{"type":"function","title":"Hangman.Engine.GameServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Hangman.Engine.GameServer.html#child_spec/1"},{"type":"function","title":"Hangman.Engine.GameServer.init/1","doc":"","ref":"Hangman.Engine.GameServer.html#init/1"},{"type":"function","title":"Hangman.Engine.GameServer.start_link/1","doc":"Spawns a game server process to be registered via `game_name`.","ref":"Hangman.Engine.GameServer.html#start_link/1"},{"type":"function","title":"Hangman.Engine.GameServer.via/1","doc":"Allows to register or look up a game server process via `game_name`.","ref":"Hangman.Engine.GameServer.html#via/1"},{"type":"module","title":"Hangman.Engine.Log","doc":"","ref":"Hangman.Engine.Log.html"},{"type":"function","title":"Hangman.Engine.Log.error/2","doc":"","ref":"Hangman.Engine.Log.html#error/2"},{"type":"function","title":"Hangman.Engine.Log.info/2","doc":"","ref":"Hangman.Engine.Log.html#info/2"},{"type":"module","title":"Hangman.Engine.TopSup","doc":"","ref":"Hangman.Engine.TopSup.html"},{"type":"function","title":"Hangman.Engine.TopSup.start/2","doc":"","ref":"Hangman.Engine.TopSup.html#start/2"}],"content_type":"text/markdown"}